/*
 * charPtr: a program demonstrating some pointer algorithms
 * copyright U. Raich 2017
 * This program is part of the workshop on embedded systems held at 
 * the University of Cape Coast in the winter semester 2017
 * It has been released under the GNU General Public License
 * see gnu.org/licenses/gpl.html
 */

#include <stdio.h>
#include <string.h>

int main() {

  char *hello="Hello World!\n";

  char *helloPtr = hello;

  printf("The values of the pointers:\n");
  printf("value of hello: 0x%0lx and of helloPtr: 0x%0lx\n",
	 (long)hello,(long)helloPtr);

  printf("De-referencing the pointer\n");
  printf("Value of *helloPtr when printed as a character: %c\n",*helloPtr);
  printf("Of course, when you print this in string format, you will print\n");
  printf("the whole string: %s\n",helloPtr);
  printf("This does not mean however, that helloPtr contains the whole string,\n");
  printf("printing as %%s does the same as a loop over all chars\n");
  printf("until the terminating '\\0' is found:\n");
  
  while (*helloPtr != '\0')
    printf("%c",*helloPtr++);
  printf("\n");
  printf("After this the pointer is %d characters further down the string\n",
	 (int)(helloPtr - hello));
  printf("The string length is: %d\n",(int)strlen(hello));
  printf("After resetting the helloPtr,\n");
  printf("let's print the string as we increment the pointer:\n");
  helloPtr = hello;
  while (*helloPtr != '\0')
    printf("%s\n",helloPtr++);  
  return 0;
}
