/*
 * pars: a program demonstrating parameter passing
 * copyright U. Raich 2017
 * This program is part of the workshop on embedded systems held at 
 * the University of Cape Coast in the winter semester 2017
 * It has been released under the GNU General Public License
 * see gnu.org/licenses/gpl.html
 */
#include <stdio.h>

int add_byValue_1(int val1,int val2) {
  return (val1+val2);
}

void add_byValue_2(int val1, int val2, int result) {
  result = val1 + val2;
}

void add_byRef_1(int val1, int val2, int *result) {
  *result = val1 + val2;
  val1=99;
}

void add_byRef_2(int *val1, int *val2, int *result) {
  *result = *val1 + *val2;
}

void add_byRef_3(int *val1, int *val2, int *result) {
  *result = *val1 + *val2;
  *val1=99;
}

void stringFunc1(char *str) {
  int i;

  printf("Part of string: ");
  for (i=0;i<5;i++)
    printf("%c",*str++);
  printf("\n");
}

void stringFunc2(char **str) {
  int i;
  char *ptr = *str;
  printf("Part of string: ");
  for (i=0;i<5;i++)
    printf("%c",*ptr++);
  printf("\n");
  *str = ptr;
}

int main() {
  int a=7, b=4, c=0;
  char *hello="Hello World!";

  c = add_byValue_1(a,b);
  printf("Passing be value, returning the result by value: %d + %d = %d\n",
	 a,b,c);
  c=0;
  add_byValue_2(a,b,c);
  printf("Now we pass also the result be value:  %d + %d = %d\n",
	 a,b,c);
  printf("Since the values are passed on the stack\n");
  printf("(and taken off the stack during the return) we cannot\n");
  printf("pass the result this way!\n");
  c=0;
  add_byRef_1(a,b,&c);
  printf("Passing the result by reference: %d + %d = %d\n",
	 a,b,c);
  c=0;
  add_byRef_2(&a,&b,&c);
  printf("Passing everything by reference: %d + %d = %d\n",
	 a,b,c);
  
  c=0;
  add_byRef_3(&a,&b,&c);
  printf("Passing everything by reference: %d + %d = %d\n",
	 a,b,c);
  printf("But I better don't change the initial values\n");
  /*
    a bit in strings 
  */
  printf("contents of hello before call to stringFunc1: 0x%lx\n",(long)hello);
  stringFunc1(hello);
  printf("contents of hello after call to stringFunc1: 0x%lx\n",(long)hello);
  printf("\ncontents of hello before call to stringFunc2: 0x%lx\n",(long)hello);
  stringFunc2(&hello);
  printf("contents of hello after call to stringFunc2: : 0x%lx\n",(long)hello); 
  return 0;
}
